[project]
name = "tiabtools"
version = "0.1"
authors = [
    { name = "Aidan MacDonald", email = "aidan.macdonald@codethink.co.uk" }
]
requires-python = ">=3.9"
dependencies = [
    "lark >= 1.1.5",
    "pyftdi >= 0.54.0",
    "pyserial >= 3.5",
    "pyusb >= 1.2.1",
    "strictyaml >= 0.2",
]

[project.optional-dependencies]
dev = [
    "mypy >= 1.3",
    "pre-commit >= 3.3.2",
    "ruff >= 0.0.269",
    "tox >= 4",
]
types = [
    "types-pyserial >= 3.5",
]
tests = [
    "coverage >= 5",
    "pytest >= 7",
    "pytest-cov >= 4",
    "pytest-sugar",
]

[project.scripts]
usbquerydemo = "tiab.apps.usbquerydemo:main"
tiabflash = "tiab.apps.flash:main"
tiabtest = "tiab.apps.flashtest:main"
tiab-temp2display = "tiab.apps.temp2display:main"

[build-system]
requires = ["setuptools"]
build-backend = "setuptools.build_meta"

[tool.mypy]
strict = true
disallow_any_unimported = true
disallow_any_expr = true
disallow_any_decorated = true
disallow_any_explicit = true
disallow_any_generics = true
disallow_subclassing_any = true
disallow_untyped_calls = true
disallow_untyped_defs = true
disallow_incomplete_defs = true
disallow_untyped_decorators = true
warn_redundant_casts = true
warn_unused_ignores = true
warn_return_any = true
warn_unreachable = true
strict_equality = true
mypy_path = "$MYPY_CONFIG_FILE_DIR/tiab-stubs"

[[tool.mypy.overrides]]
module = "strictyaml.*"
disallow_any_unimported = false
disallow_any_explicit = false
disallow_subclassing_any = false
disallow_untyped_defs = false
disallow_incomplete_defs = false

[[tool.mypy.overrides]]
module = "usb.*"
disallow_untyped_defs = false
disallow_incomplete_defs = false

[[tool.mypy.overrides]]
module = "pyftdi.*"
disallow_any_unimported = false
disallow_any_explicit = false
disallow_untyped_defs = false
disallow_incomplete_defs = false

[tool.pytest.ini_options]
testpaths = "tests"

[tool.coverage.run]
source = ["src/"]
omit = ["src/tiab/apps/*"]

[tool.ruff]
select = ["ALL"]
ignore = [
    "A003",     # class attribute "shadowing" a builtin; it's not really an issue.
    "ANN001",   # better with mypy
    "ANN101",   # 'self' arguments need not be typed, cf. PEP 673.
    "C901",     # use your own judgement re. function complexity
    "E501",     # use your own judgement on line length
    "FA100",    # we use Python 3.9+ so this warning is not applicable
    "D",        # allow missing documentation for now
    "N812",     # style
    "PLR0911",  # "too many return statements" is a useless diagnostic
    "Q000",     # style
    "RET503",   # better with mypy
    "T201",     # TODO: ban print() for library code but not app code
    "TD001",    # pointless
    "TD002",    # pointless
    "TD003",    # pointless
    "FIX002",   # Ignore lines marked as TODO
    "FIX003",   # Ignore lines marked as XXX
]
